/* Tabela TABEPREC: TABELA DE PREOS*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TABEPREC */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABEPREC,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_TABEPREC 
AFTER DELETE OR INSERT OR UPDATE
ON TABEPREC FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDFILIAL ,'NULL') <> NVL(:OLD.CDFILIAL ,'NULL') THEN
			V_DESC   := 'Filial ' || '' || NVL(:NEW.CDFILIAL,'');
		END IF;
		IF NVL(:NEW.CDTABEPREC ,'NULL') <> NVL(:OLD.CDTABEPREC ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Cd da Tabela de Preo ' || ' ' || NVL(:NEW.CDTABEPREC,'');
		END IF;
		IF NVL(:NEW.NMTABEPREC ,'NULL') <> NVL(:OLD.NMTABEPREC ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Nm da Tabela de Preo ' || ' ' || NVL(:NEW.NMTABEPREC,'' );
		END IF;
		IF NVL(:NEW.DTULTATUTBPR,TO_DATE('01/01/0001','DD/MM/YYYY'))  <> NVL(:OLD.DTULTATUTBPR,TO_DATE('01/01/0001','DD/MM/YYYY'))  THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Dt Ult Atu do Preo ' || ' ' || NVL(:NEW.DTULTATUTBPR,'');
		END IF;
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDTABEPREC;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Filial '                || '' || NVL(:NEW.CDFILIAL,''    )  	  || ' ' ||
                  'Cd da Tabela de Preo ' || '' || NVL(:NEW.CDTABEPREC,''  )     || ' ' ||
                  'Nm da Tabela de Preo ' || '' || NVL(:NEW.NMTABEPREC,'' )   	  || ' ' || 
                  'Dt Ult Atu do Preo '   || '' || NVL(:NEW.DTULTATUTBPR,'');
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDTABEPREC;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Filial '                || '' || NVL(:OLD.CDFILIAL,''    )  	  || ' ' ||
                  'Cd da Tabela de Preo ' || '' || NVL(:OLD.CDTABEPREC,''  )     || ' ' ||
                  'Nm da Tabela de Preo ' || '' || NVL(:OLD.NMTABEPREC,'' )   	  || ' ' || 
                  'Dt Ult Atu do Preo '   || '' || NVL(:OLD.DTULTATUTBPR,'');
      V_ITPESQ := :OLD.CDFILIAL||:OLD.CDTABEPREC;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('TABEPREC',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_TABEPREC','5.20.001'); END;
/


